#include <stdio.h>
#include <direct.h>
#include <conio.h>
#include <string.h>

#include <stdinc.c>
#include <keycodes.c>

#define MaxX 8
#define MaxY 8

typedef struct {
  char dir[MaxX][MaxY][9];
  byte x, y;
} list;

void list_init (list *l);
void list_fill (list *l);
boolean add (list *l, char *s);
void list_show (list *l);
void list_move (list *l, char inkey);
void list_draw (list l, boolean b);
void list_reinit (list *l);
void instruct ();

void main (char inkey, char *argv[3]) {
  list l;
  char curDir[MAXDIR];

  if (strcmp (argv[1], "/?") == 0) {
    instruct ();
    return;
  } 
  
  getcurdir (0, curDir);
  cursoff ();

  list_reinit (&l);

  do {
    if (!kbhit ()) continue;
    
    inkey = getch ();
    if (!inkey) {
      inkey = getch ();
      switch (inkey) {
        case Up :
        case Down :
        case Left :
        case Right :
          list_move (&l, inkey);
      }
    } else {
      switch (inkey) {
        case Enter :
          chdir (l.dir[l.x][l.y]);
          if (strcmp (l.dir[l.x][l.y], ".") != 0) {
            list_reinit (&l);
            break;
          }
        case Space :
          chdir (l.dir[l.x][l.y]);
          inkey = Esc;
          break;
        case Esc :
          chdir (strcat ("\\", curDir));

      }
    }
  } until (inkey == Esc);

  curson ();
  clrscrn ();
}

void list_init (list *l) {
  for (l->x = 0; l->x < MaxX; l->x++)
    for (l->y = 0; l->y < MaxY; l->y++)  
      strcpy (l->dir[l->x][l->y], 0);

  l->x = 0; l->y = 0;
}

void list_fill (list *l) {
  struct ffblk file;
  int done = findfirst ("*.*", &file, 0x0010);
  
  add (l, ".");

  do {
    done = findnext (&file);
    if (done == 0 and file.ff_attrib == 0x0010) 
      if (add (l, file.ff_name)) return;
  
  } while (done == 0);
}

boolean add (list *l, char *s) {
  strcpy (l->dir[l->x][l->y], s);

  l->y++;
  if (l->y == MaxY) {
    l->y = 0;
    l->x++;
    if (l->x == MaxX) return true;
  }

  return false;
}

void list_show (list *l) {
  byte x, y;  
  clrscrn ();

  for (x = 0; x < MaxX; x++)
    for (y = 0; y < MaxY; y++) {
      poscurs (y * 3 + 2, x * 10 + 1);
      if (!l->dir[x][y]) return;
      printf ("%s", l->dir[x][y]);
    }
}

void list_move (list *l, char ch) {
  small addx, addy;

  switch (ch) {
    case Up :
      addy = -1; addx = 0;
      break;
    case Down :
      addy = 1; addx = 0;
      break;
    case Left :
      addy = 0; addx = -1;
      break;
    case Right :
      addy = 0; addx = 1;
  }

  list_draw (*l, false);

  do {
    l->x += addx; l->y += addy;

    if (l->x == 255) l->x = MaxX - 1;
    if (l->x == MaxX) l->x = 0;
    if (l->y == 255) l->y = MaxY - 1;
    if (l->y == MaxY) l->y = 0;
  } while (strcmp (l->dir[l->x][l->y], 0) == 0);

  list_draw (*l, true);
}

void list_draw (list l, boolean b) {
  poscurs (l.y * 3 + 1, l.x * 10);
  if (b)
    printf ("ͻ");
  else
    printf ("          ");

  poscurs (l.y * 3 + 2, l.x * 10);
  if (b)
    printf ("");
  else
    printf (" ");

  poscurs (l.y * 3 + 2, l.x * 10 + 9);
  if (b)
    printf ("");
  else
    printf (" ");

  poscurs (l.y * 3 + 3, l.x * 10);
  if (b)
    printf ("ͼ");
  else 
    printf ("          ");
}

void list_reinit (list *l) {
  char curDir[MAXDIR];

  list_init (l);
  list_fill (l);
  list_show (l);
  l->x = 0; l->y = 0;
  list_draw (*l, true);

  getcurdir (0, curDir);
  poscurs (0, 0);
  printf ("%c:\\%s", getdisk () + 'A', curDir);
}

void instruct () {
  printf ("\nNavigate through the directories with the arrow keys.\n");
  printf ("Press Esc to cancel, Enter to see directory's directories,\n");
  printf ("or the Space Bar to go a directory.\n");
}
